<style>
.vanish {
  display: none;
}

.label-style {
  text-align: right;
  font-size: 16px;
}

.label-hint-style {
  text-align: right;
  font-size: 12px;
  font-style: italic;
  font-weight: bold;
}

.input-style {
  text-align: left;
  font-size: 16px;
  height: 30px;
  width: 300px;
}

.select-style {
  height: 100px;
  width: 300px;
  font-size: 16px;
}

.table-style {
  border: 1;
  border-spacing: 10px;
  border-color: black;
}

.tab {
  overflow: hidden;
}

.tab button {
  float: left;
  border: 1px solid #000;
  outline: none;
  cursor: pointer;
  padding: 9px 9px;
  transition: 0.3s;
  font-size: 17px;
  color: #888;
}

.tab button:hover {
  background-color: #ddd;
}

.tab button.active {
  background-color: #fff;
  font-weight: bold;
  border: 2px solid #000;
  color: #000;
}

.tabcontent {
  display: none;
  padding: 6px 12px;
  border: 2px solid #000;
}
</style>

<script>
var env_list = {
  "NON-PROD": ["DEV", "SIT", "MODEL", "CAP"],
  "PROD": ["PROD"]
}

window.onload = function() {
  var env_type_choice = document.getElementById("env_type");
  var env_name_choice = document.getElementById("env_name");

  for (var env_type_item in env_list) {
    env_type_choice.options[env_type_choice.options.length] = new Option(env_type_item, env_type_item);
  }

  env_type_choice.onchange = function() {
    env_name_choice.length = 1;
    env_name_item = env_list[this.value];
    for (var i = 0; i < env_name_item.length; i++)  {
      env_name_choice.options[env_name_choice.options.length] = new Option(env_name_item[i], env_name_item[i]);
    }
  }
}

function openRequestForm(evnt, tabName) {
  var i, tabcontent, tablinks;
  tabcontent = document.getElementsByClassName("tabcontent");
  for (i = 0; i < tabcontent.length; i++) {
    tabcontent[i].style.display = "none";
  }
  tablinks = document.getElementsByClassName("tablinks");
  for (i = 0; i < tablinks.length; i++) {
    tablinks[i].className = tablinks[i].className.replace(" active", "");
    tablinks[i].style.backgroundColor = "#eee";
    tablinks[i].style.color = "#888";
  }
  document.getElementById(tabName).style.display = "block";
  evnt.currentTarget.className += " active";
  evnt.currentTarget.style.backgroundColor = "#fff";
  evnt.currentTarget.style.color = "#000";

  jQuery.ajax({
    url: "/rest/gadget/1.0/currentUser",
    type: 'get',
    dataType: 'json',
    async: false,
    success: function(data) {
      user_z_id = data.username;
      user_full_name = data.fullName;
      user_email_address = data.email;
    }
  });
  document.getElementById("user_email").value = user_email_address;
  document.getElementById("user_ws_email").value = user_email_address;

  if (tabName == 'userDecommForm') {
    document.getElementById("user_form_div_xid").className = 'vanish';
    document.getElementById("retire_user_ws").className = 'appear';
  }

  if (tabName == 'teamDecommForm') {
    document.getElementById("retire_team_ws").className = 'appear';
    document.getElementById("popup_warning").className = 'vanish';
  }
}
</script>

<div class="tab">
  <button class="tablinks active" onclick="openRequestForm(event, 'teamDecommForm')">Request Team Workspace</button>
  <button class="tablinks" onclick="openRequestForm(event, 'userDecommForm')">Request User Workspace</button>
</div>

<div id="teamDecommForm" class="tabcontent" style="display: block;">
  <table class="table-style">
    <tr>
      <td class="label-style"><label for="team_name">What is your team's name? <br/><span class="label-hint-style">Example: AUTO_BUSINESS_OPTIMIZATION </span></label></td>
      <td class="input-style"><input class="input-style" id="team_name" name="team_name" type="text" value="" /></td>
    </tr>
    <tr>
      <td class="label-style"><label for="team_owner">Who is the team owner? <br/><span class="label-hint-style">Please provide the full name.</span></label></td>
      <td class="input-style"><input class="input-style" id="team_owner" name="team_owner" type="text" value="" /></td>
    </tr>
    <tr>
      <td class="label-style"><label for="env_type">Environment Type: </label></td>
      <td class="input-style">
        <select name="env_type" id="env_type" class="input-style">
          <option value="" selected="selected" class="input-style">Please choose the environment type</option>
        </select>
      </td>
    </tr>
    <tr>
      <td></td>
      <td class="input-style">
        <select name="env_name" id="env_name" multiple class="select-style">
          <option value="" selected="selected">Select all the environments as applicable</option>
        </select>
      </td>
    </tr>
    <tr>
      <td class="label-style"><label for="user_email">Your Email Address: <br/></label></td>
      <td class="input-style"><input class="input-style" id="user_email" name="user_email" type="email" value="" /></td>
    </tr>

<script>
var user_full_name = "";
var user_email_address = "";
var user_z_id = "";

jQuery.ajax({
  url: "/rest/gadget/1.0/currentUser",
  type: 'get',
  dataType: 'json',
  async: false,
  success: function(data) {
    user_z_id = data.username;
    user_full_name = data.fullName;
    user_email_address = data.email;
  }
});
document.getElementById("user_email").value = user_email_address;

var jira_summary = "";
var jira_description = "";
var sfc_env_params = {
  "nonprod": {
    "aws_account_id": "894431826386",
    "kms_key_id": "e1821f16-b8d3-471e-b01f-11bd3e85c8fe",
    "env_prefix": "qa-r-",
    "env_short_name": {
      "dev": "D",
      "sit": "S",
      "model": "M",
      "cap": "C"
    },
    "user_iam_role_id": "AROA5AQCKSHJJM42CXO4H"
  },
  "prod": {
    "aws_account_id": "777181025923",
    "kms_key_id": "68a2c6ee-98ce-44f2-b33c-f85dc80682ea",
    "env_prefix": "",
    "env_short_name": {
      "prod": "P"
    },
    "user_iam_role_id": "AROA3J44ZK2BQ4MTG2FX7"
  }
};
var access_types = {
  "ro": "Read-Only",
  "rw": "Read-Write"
};
var s3_bucket = "s3://eda-tf-aws-analytics-s3-<env_prefix><env_name>-us-east-1-workspaces";
var s3_prefix = "team/TEAM_<team_name>_<env_short_name>";
var s3_kms_key = "arn:aws:kms:us-east-1:<account-id>:key/<kms-key-id>";
var iam_role_arn = "arn:aws:iam::<aws_account_id>:role/eda-sf-iam-<env_prefix><env_type>-us-east-1-t-<team_short_name>-analyst-<access_type>";

function validate_fields() {
  var v_env_type = $('#env_type').val();
  var v_env_names = String($('#env_name').val());
  var v_team_name = $('#team_name').val();

  // Validating field: Team Name
  if (v_team_name.length == 0) {
    alert("'Team Name' cannot be blank !");
    return false;
  }

  // Validating field: Environment Type
  if (v_env_type == "") {
    alert("Please make an appropriate selection for 'Environment Type' field");
    return false;
  }

  // Validating field: Environment Name
  if (v_env_names == "") {
    alert("Please make sure you select at least one environment for this request");
    return false;
  }

  return true;
}

function update_jira_fields(jira_collector_id, jira_team_name, jira_request_type) {
  var jira_team_id = "";
  var jira_epic_link = "";
  var env_type = $('#env_type').val();
  var env_names = String($('#env_name').val());
  var team_owner = $('#team_owner').val();
  var isTeamNeeded = $("input[name='teamNeeded']:checked").val();
  var isSINeeded = $("input[name='SINeeded']:checked").val();
  var jira_user_x_id = "".concat("X_", user_z_id);
  var jira_user_full_name = user_full_name
  var jira_user_email_address = user_email_address;

  if (jira_team_name == "CumulusSquad") {
    jira_team_id = "2603";
    jira_epic_link = "CIA-52474";
  } else if (jira_team_name == "SnowPanthers") {
    jira_team_id = "2489";
    jira_epic_link = "CIA-41599";
  }

  var team_name = $('#team_name').val().toUpperCase().replace("-", "_").replace(" ", "_");
  if (team_name.toUpperCase().startsWith("TEAM_")) {
    team_name = team_name.substring(5);
  }

  var team_short_name = $('#short_team_name').val().toUpperCase().replace("-", "_").replace(" ", "_");
  if (team_short_name.toUpperCase().startsWith("TEAM_")) {
    team_short_name = team_short_name.substring(5);
  }

  if (jira_request_type == "aws_team_setup") {
    jira_summary = "Analytics SR: New Team Setup Request".concat(" - ", team_name);
    jira_summary = jira_summary.concat(" - ", env_type);
    jira_description = "".concat("\nPlease setup the Analyst team workspace in AWS S3 using the following details:", "\n");
    jira_description = jira_description.concat("\n\n||Field Name||", "Value||");
    jira_description = jira_description.concat("\n|Team Name|", team_name);
    jira_description = jira_description.concat("|\n|Team Short Name|", team_short_name);
    jira_description = jira_description.concat("|\n|Team Owner's Name|", team_owner);
    jira_description = jira_description.concat("|\n|Environments|", env_names);
    jira_description = jira_description.concat("|\n", "\n");
    jira_description = jira_description.concat("\n*Snowflake Storage Integration Setup Needed?* ", isSINeeded);
    jira_description = jira_description.concat("\n", "\n");
  }

  if (jira_request_type == "aws_si_setup") {
    jira_summary = "Analytics SR: Storage Integration Setup Request".concat(" - ", team_name);
    jira_summary = jira_summary.concat(" - ", env_type);
    jira_description = "".concat("\nPlease setup the Storage Integration for the Analyst team workspace in AWS S3 using the following details:", "\n");
    jira_description = jira_description.concat("\n\n||Field Name||", "Value||");
    jira_description = jira_description.concat("\n|Team Name|", team_name);
    jira_description = jira_description.concat("|\n|Team Short Name|", team_short_name);
    jira_description = jira_description.concat("|\n|Team Owner's Name|", team_owner);
    jira_description = jira_description.concat("|\n|Environments|", env_names);
    jira_description = jira_description.concat("|\n", "\n");
    jira_description = jira_description.concat("\n*AWS Team Workspace setup needed?:* ", isTeamNeeded);
    jira_description = jira_description.concat("\n", "\n");
  }

  if (jira_request_type == "sfc_si_setup") {
    var sfc_env_type = env_type.replace("-", "").toLowerCase();
    var sfc_team_name = "";
    var sfc_env_name = "";
    var sfc_s3_bucket = "";
    var sfc_iam_role_arn = "";
    var sfc_kms_key_arn = "";
    jira_summary = "";
    jira_description = "";

    jira_summary = jira_summary.concat("Analytics SR: Storage Integration Setup Request - ", team_name, " - ", env_type);
    jira_description = jira_description.concat("\nPlease setup the Storage Integration for the Analyst team workspace in AWS S3 using the following details:", "\n");

    for (let env_name of env_names.split(",")) {
      for (let access_type in access_types) {
        sfc_env_name = env_name.toLowerCase();
        sfc_team_name = "".concat("TEAM_", team_name, "_", sfc_env_params[sfc_env_type]["env_short_name"][sfc_env_name]);
        sfc_s3_bucket = s3_bucket.replace("<env_prefix>", sfc_env_params[sfc_env_type]["env_prefix"]).replace("<env_name>", sfc_env_name);
        sfc_iam_role_arn = iam_role_arn.replace("<aws_account_id>", sfc_env_params[sfc_env_type]["aws_account_id"]);
        sfc_iam_role_arn = sfc_iam_role_arn.replace("<env_prefix>", sfc_env_params[sfc_env_type]["env_prefix"]);
        sfc_iam_role_arn = sfc_iam_role_arn.replace("<env_type>", sfc_env_type);
        sfc_iam_role_arn = sfc_iam_role_arn.replace("<team_short_name>", team_short_name.replace("_", "-"));
        sfc_iam_role_arn = sfc_iam_role_arn.replace("<access_type>", access_type);
        sfc_kms_key_arn = s3_kms_key.replace("<account-id>", sfc_env_params[sfc_env_type]["aws_account_id"]);
        sfc_kms_key_arn = sfc_kms_key_arn.replace("<kms-key-id>", sfc_env_params[sfc_env_type]["kms_key_id"]);
        
        jira_description = jira_description.concat("\n+*", sfc_team_name, "*+: ", "(", access_types[access_type], " SI)");
        jira_description = jira_description.concat("\n||Parameter||", "Value||");
        jira_description = jira_description.concat("\n|Permission|", access_type.toUpperCase(), "|");
        jira_description = jira_description.concat("\n|S3 Bucket|", sfc_s3_bucket, "|");
        jira_description = jira_description.concat("\n|S3 Prefix(s)|", "team/".concat(sfc_team_name, "/"));
        jira_description = jira_description.concat("\n|IAM Role ARN|", sfc_iam_role_arn, "|");
        jira_description = jira_description.concat("\n|KMS Key ARN|", sfc_kms_key_arn, "|");
        jira_description = jira_description.concat("\n|External ID|", " |");
        jira_description = jira_description.concat("\n", "\n");
      }
    }

    jira_description = jira_description.concat("\nPlease create the External Stages for the following sub-prefixes/schemas in each of the databases.\n");
    jira_description = jira_description.concat("\n\n* WORK\n* CORE\n* TEST\n* STATIC\n\n");
    jira_description = jira_description.concat("\n*JIRA request submitted to Cumulus Squad?* ", "YES");
    jira_description = jira_description.concat("\n", "\n");
  }

  if (jira_request_type == "aws_user_setup") {
    var hasXID = $("input[name='hasXID']:checked").val();
    var isUserOnboarded = $("input[name='isUserOnboarded']:checked").val();

    jira_summary = "Analytics SR: New User Setup Request".concat(" - ", jira_user_full_name);
    jira_description = "".concat("\nPlease setup the Analyst user workspace in AWS S3 using the following details:", "\n");
    jira_description = jira_description.concat("\n\n||Field Name||", "Value||");
    jira_description = jira_description.concat("\n|User's X-ID|", jira_user_x_id);
    jira_description = jira_description.concat("|\n|User already has an X-ID|", hasXID);
    jira_description = jira_description.concat("|\n|User has onboarded to the AD group|", isUserOnboarded);
    jira_description = jira_description.concat("|\n|Environments|", "All NonProd and Prod");
    jira_description = jira_description.concat("|\n", "\n");
  }

  if (jira_request_type == "sfc_user_si_setup") {
    var sfc_env_type = "";
    var sfc_kms_key_arn = "";
    var sfc_s3_bucket = "";
    var sfc_s3_url = "";
    var sfc_user_iam_role_id = "";
    var user_s3_prefix = "";
    var userNeeded = $("input[name='userNeeded']:checked").val();
    var user_z_id_upper = user_z_id.toUpperCase();
    var env_short_name_upper = "";
    jira_summary = "";
    jira_description = "";

    jira_summary = jira_summary.concat("Analytics SR: User External Stage(s) Setup Request - ", user_z_id);
    jira_description = jira_description.concat("\nPlease setup the External Stages the Analyst user workspace in AWS S3 using the following details:", "\n");

    for (let env_name of ["dev", "sit", "model", "cap", "prod"]) {
      env_short_name_upper = env_name.substring(0,1).toUpperCase();
      jira_description = jira_description.concat("\n+*USER_SANDBOX_", env_short_name_upper, "*+: (RW ESTG)");

      if (env_name == "prod") {
        sfc_env_type = "prod";
      } else {
        sfc_env_type = "nonprod";
      }

      sfc_s3_bucket = s3_bucket.replace("<env_prefix>", sfc_env_params[sfc_env_type]["env_prefix"]).replace("<env_name>", env_name);
      sfc_user_iam_role_id = sfc_env_params[sfc_env_type]["user_iam_role_id"]
      user_s3_prefix = sfc_user_iam_role_id.concat(":X_", user_z_id_upper);
      sfc_s3_url = sfc_s3_bucket.concat("/user/", user_s3_prefix, "/");

      sfc_kms_key_arn = s3_kms_key.replace("<account-id>", sfc_env_params[sfc_env_type]["aws_account_id"]);
      sfc_kms_key_arn = sfc_kms_key_arn.replace("<kms-key-id>", sfc_env_params[sfc_env_type]["kms_key_id"]);
        
      jira_description = jira_description.concat("\n||Parameter||", "Value||");
      jira_description = jira_description.concat("\n|Permission|RW", "|");
      jira_description = jira_description.concat("\n|Database Name|USER_SANDBOX_", env_short_name_upper, "|");
      jira_description = jira_description.concat("\n|Schema Name|", user_z_id_upper, "|");
      jira_description = jira_description.concat("\n|External Stage Name|ESTG_ANALYTICS_USER_SANDBOX_", user_z_id_upper, "_RW");
      jira_description = jira_description.concat("\n|S3 URL|", sfc_s3_url, "|");
      jira_description = jira_description.concat("\n|Storage Integration Name|SI_ANALYTICS_USER_SANDBOX_RW_", env_short_name_upper, "|");
      jira_description = jira_description.concat("\n|KMS Key ARN|", sfc_kms_key_arn, "|");
      jira_description = jira_description.concat("\n", "\n");
    }

    jira_description = jira_description.concat("\n*Is the user's S3 prefix available in AWS?*", " ");
    if (userNeeded == "YES") {
      jira_description = jira_description.concat("NO, Cumulus team is working on the setup.");
    } else {
      jira_description = jira_description.concat("YES");
    }
    jira_description = jira_description.concat("\n", "\n");
  }

  window.ATL_JQ_PAGE_PROPS[jira_collector_id].fieldValues.summary = jira_summary;
  window.ATL_JQ_PAGE_PROPS[jira_collector_id].fieldValues.description = jira_description;
  window.ATL_JQ_PAGE_PROPS[jira_collector_id].fieldValues.customfield_10300 = jira_team_id;
  window.ATL_JQ_PAGE_PROPS[jira_collector_id].fieldValues.customfield_10000 = jira_epic_link;
  window.ATL_JQ_PAGE_PROPS[jira_collector_id].fieldValues.fullname = jira_user_full_name;
  window.ATL_JQ_PAGE_PROPS[jira_collector_id].fieldValues.email = jira_user_email_address;
}
</script>

<script src="https://jira.int.ally.com/plugins/servlet/issueCollectorBootstrap.js?collectorId=980ec4e8&locale=en_US"></script>
<script src="https://jira.int.ally.com/plugins/servlet/issueCollectorBootstrap.js?collectorId=7cde3c07&locale=en_US"></script>

<!-- Requires jQuery! -->
<script type="text/javascript">
// 2603 = Cumulus Squad; 2489 = Snow Panthers
$(document).ready(function() {
  window.ATL_JQ_PAGE_PROPS = $.extend(window.ATL_JQ_PAGE_PROPS, {
    '980ec4e8': {
      "triggerFunction": function (showCollectorDialog) {
        //Requires that jQuery is available! 
        jQuery("#aws_team_setup").click(function (e) {
          e.preventDefault();
          if (validate_fields()) {
            update_jira_fields("980ec4e8", "CumulusSquad", "aws_team_setup");
            showCollectorDialog();
            document.getElementById("finalEvent").textContent = "Request(s) have been submitted ! Please give us a few days to work on your requests.";
          }
        });
        jQuery("#aws_si_setup").click(function (e) {
          e.preventDefault();
          if (validate_fields()) {
            update_jira_fields("980ec4e8", "CumulusSquad", "aws_si_setup");
            showCollectorDialog();

            // Start tracking the popup window
            var observer = new MutationObserver(function(mutationsList, observer) {
              for (var mutation of mutationsList) {
                setTimeout(function(){
                  $('#sfc_si_setup').trigger('click');
                }, 500);
                observer.disconnect();
              }
            });
            observer.observe(document.getElementById("atlwdg-blanket"), {attributes: true, attributeFilter: ['style']});

            document.getElementById("finalEvent").textContent = "You are still one more step to finish the process - Please submit 'Snowflake Team Request'.";
          }
        });
        jQuery("#aws_user_setup").click(function (e) {
          e.preventDefault();
          if (awsUserWSChosen() == "YES") {
            update_jira_fields("980ec4e8", "CumulusSquad", "aws_user_setup");
            showCollectorDialog();
            if (userSIChosen() == "YES") {
              var observer = new MutationObserver(function(mutationsList, observer) {
                for (var mutation of mutationsList) {
                  setTimeout(function(){
                    $('#sfc_user_si_setup').trigger('click');
                  }, 500);
                  observer.disconnect();
                }
              });
              observer.observe(document.getElementById("atlwdg-blanket"), {attributes: true, attributeFilter: ['style']});
            }
          } else {
            $('#sfc_user_si_setup').trigger('click');
          }
          document.getElementById("finalEvent").textContent = "Request(s) have been submitted ! Please give us a few days to work on your requests.";
        });
      },
      "fieldValues": {
        summary: "",
        description: "",
        priority: "3",
        fullname: "",
        email: ""
      }
    },
    '7cde3c07': {
      "triggerFunction": function (showCollectorDialog) {
        //Requires that jQuery is available! 
        jQuery("#sfc_si_setup").click(function (e) {
          e.preventDefault();
          if (validate_fields()) {
            update_jira_fields("7cde3c07", "SnowPanthers", "sfc_si_setup");
            showCollectorDialog();
            document.getElementById("finalEvent").textContent = "Request(s) have been submitted ! Please give us a few days to work on your requests.";
          }
        });
        jQuery("#sfc_user_si_setup").click(function (e) {
          e.preventDefault();
          update_jira_fields("7cde3c07", "SnowPanthers", "sfc_user_si_setup");
          showCollectorDialog();
          document.getElementById("finalEvent").textContent = "Request(s) have been submitted ! Please give us a few days to work on your requests.";
        });
      },
      "fieldValues": {
        summary: "",
        description: "",
        priority: "3",
        fullname: "",
        email: ""
      }
    }
  });
});
</script>

    <tr id="retire_team_ws" class="appear">
      <td class="label-style"></td>
      <td class="input-style">
        <div>
          <button  class="aui-button keysight-button aui-button-primary conf-macro output-inline" href="#"  data-hasbody="false" data-macro-name="button"  id="aws_team_setup">
          Submit Request
          </button>
        </div>
      </td>
    </tr>
    <tr id="si_setup" class="vanish">
      <td class="label-style"></td>
      <td class="input-style">
        <div>
          <button  class="aui-button keysight-button aui-button-primary conf-macro output-inline" href="#" data-hasbody="false" data-macro-name="button" id="aws_si_setup">
          Submit Request<u>s</u>
          </button>
          <button class="vanish" href="#" data-hasbody="false" data-macro-name="button" id="sfc_si_setup">
          Snowflake Team Request
          </button>
        </div>
      </td>
    </tr>
    <tr id="popup_warning" class="vanish" style="text-align: right;">
      <td colspan="2" style="font-size: 20px; color: red;">Please expect two pop-up windows for request submission !</td>
    </tr>
  </table>
</div>

<div id="userDecommForm" class="tabcontent" style="display: none;">
  <table class="table-style">
    <tr>
      <td class="label-style"><label for="user_ws_email">Your Email Address: <br/></label></td>
      <td class="input-style"><input class="input-style" id="user_ws_email" name="user_ws_email type="email" value="" /></td>
    </tr>
    <tr id="user_form_div_xid" class="vanish" style="text-align: right;">
      <td colspan="2" style="font-size: 12px; color: red;">Please note that this request will remove your personal S3 workspace from all the environments.</td>
    </tr>
    <tr>
      <td class="label-style"></td>
      <td class="input-style">
        <div id="retire_user_ws" class="appear">
          <button  class="aui-button keysight-button aui-button-primary conf-macro output-inline" href="#"  data-hasbody="false" data-macro-name="button"  id="aws_user_setup">
          Submit Request
          </button>
        </div>
      </td>
    </tr>
  </table>
</div>
